/********************************************************************************************************
**********************Global Variables*******************************************************************
*********************************************************************************************************
********************************************************************************************************/
//colors of default palette
var tabColors= ['rgb(147, 174, 229)','rgb(255, 218, 117)','rgb(188, 204, 157)','rgb(239, 157, 159)','rgb(186, 167, 225)','rgb(155, 191, 180)','rgb(247, 180, 130)','rgb(216, 171, 192)','rgb(147, 229, 174)','rgb(255, 117, 218)','rgb(188, 157, 204)','rgb(239, 159, 157)','rgb(186, 225, 167)','rgb(155, 180, 191)','rgb(247, 130, 180)','rgb(216, 192, 171)','rgb(174, 147, 229)','rgb(218, 255, 117)','rgb(204, 188, 157)','rgb(157, 239, 159)','rgb(167, 186, 225)','rgb(191, 155, 180)','rgb(180, 247, 130)','rgb(171, 216, 192)','rgb(229, 174, 147)','rgb(117, 218, 255)','rgb(157, 204, 188)','rgb(159, 157, 239)','rgb(225, 167, 186)','rgb(180, 191, 155)','rgb(130, 180, 247)','rgb(192, 171, 216)'];
var newVersion;
//variable 'fadedeg' tracks fade degree starting 0 to 9 translates to mozopacity 0 to 1 **some explaination mising**.
var fadedeg, scheme, ctVersion;
//variable 'clr' tracks the class (in the stylesheet) of the tab
var clr=0;
//Out variable to manage the session(restore)
var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].getService(Components.interfaces.nsISessionStore);
var beta;//=false;
var satmax;//=95;
var satmin;//=30;
var lummax;//=78;
var lummin;//=68;
var txtreverse;
var enabledomain;
var domain1,domain2,domain3,domain4,domain5;
function ctFirstRun()
	{
	gBrowser.removeEventListener('load', ctFirstRun, true);
	var clrUrl;
	/*
	if(beta)
		clrUrl = 'http://colorfultabs.blogspot.com';
	else
	*/
	
	clrUrl = 'http://colorfultabs.googlepages.com/installed?v='+escape(newVersion);
	
	dump("\nctlog:\t"+clrUrl)
	gBrowser.selectedTab = gBrowser.addTab(clrUrl); 
	}

/********************************************************************************************************
**function clrtabsInit() is called from clrtab.xul as "window.addEventListener('load', clrtabsInit, false); *****
*********************************************************************************************************
********************************************************************************************************/
/*
function setTabOpac()
	{
	}
*/
function clrtabsInit()
	{
	dump("\nColorfulTabs Log: clrtabsInit");
	setCtPref();

	/*****************************************************************************************
	***********************************this is for the firstrun*******************************
	*****************************************************************************************/
	var ctEM = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	// Change extension-guid to the GUID of the extension whose version you want to retrieve; // e.g. foxyproxy@eric.h.jung for FoxyProxy
	var ctAddon = ctEM.getItemForID("{0545b830-f0aa-4d7e-8820-50a4629a56fe}");
	newVersion = ctAddon.version;
	dump("\nname: "+ctAddon.name);
	dump("\nversion: "+newVersion);
	
	if(ctAddon.name.toLowerCase().indexOf("beta")>=0 || newVersion.toLowerCase().indexOf("beta"))
		{
		Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).setBoolPref("browser.dom.window.dump.enabled", true);
		beta = true;
		}
	else
		{
		beta = false;
		}
	
	if(ctVersion != newVersion)
		{
		if(window.navigator.onLine)
			{
			
			Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).setCharPref("extensions.clrtabs.firstrun", newVersion);
			gBrowser.addEventListener('load', ctFirstRun, true);
			}

		else 	{
			dump("\nYou're offline");
			}
		}
	/******************************************************************************************************************
	**************************** END END END END END END END END END END END END END END*******************************
	******************************************************************************************************************/
	
	chkRestore();//checks if u are restoring the session or not
	//calcTabClr();
	//var ctContainer = getBrowser();
	gBrowser.addEventListener("SSTabRestoring",restoreTabClr,false);
	gBrowser.addEventListener("TabOpen", calcTabClr, false);
	gBrowser.addEventListener("TabMove", getMovedTab, false);
	gBrowser.addEventListener("TabClose", tabrem, false);
	gBrowser.addEventListener("TabSelect", fadeAllTabs, false);
	gBrowser.mStrip.addEventListener("mouseover", effectMouseIn, false);
	gBrowser.mStrip.addEventListener("mouseout", effectMouseOut, false);
	//if(Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("extensions.clrtabs.menu"))
	initTabcontext();
	window.removeEventListener('load', clrtabsInit, false);
	return;
	}

function clrtabsUnload()
	{
	clrPrefObserver.unregister();
	}
function chkRestore()
	{
	var tab,tabClr;
	if(Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getIntPref("browser.startup.page") !=3)
		{//we are not restoring the session. we are opening the homepage(s).
		var tabLen = gBrowser.mPanelContainer.childNodes.length;
		for(var tn=0;tn<tabLen;tn++)
			{
			//dump("\nColorfulTabs Log: get the tab, calc color and send to setcolor: "+tn)
			tab = gBrowser.mTabContainer.childNodes[tn];
			dump("\nColorfulTabs Log: "+'\t'+ss.getTabValue(tab,"ctreadonly"));
			
			switch (scheme)
				{
				case 0:
					//user chose to color tabs with default palette
					dump("\n\tclr before: "+clr);
					if(ss.getTabValue(tab,"ctreadonly") == 1)
						break;				
					tabClr = tabColors[clr%32];					
					setColor(tab,tabClr);
					clr++;
					break;
				case 1:
					dump('\nColorfulTabs Log: scheme value: random');
					if(ss.getTabValue(tab,"ctreadonly") == 1)
						break;				
					//user chose to color tabs randomly
					var oldtabClr=ss.getTabValue(tab,"tabClr" );
					if(oldtabClr)
						{
						tabClr = oldtabClr;
						}
					else
						{
						clrSat = clrRand(satmin,satmax);	//for keeping saturation to match the old static template we need the saturation between 30 and 95;ideally could be min 30; add advanced  prefs later
						clrLum = clrRand(lummin,lummax);	//for keeping saturation to match the old static template we need the luminance between 68 and 78
						tabClr ='hsl('+Math.abs(clrHash(tab.getAttribute('linkedpanel').replace(/panel/,"")))%360+','+clrSat+'%,'+clrLum+'%)';
						}					
					//ss.setTabValue(tab, "tabClr", tabClr);
					setColor(tab,tabClr);
					break;
				case 2:
					dump("\nColorfulTabs Log: user chose to color tabs with URl scheme");
					tab.linkedBrowser.addProgressListener(clrUrlListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
					//tabClr ='hsl('+Math.abs(clrHash(clrURL))%360+','+50+'%,'+50+'%)';
					//tn += 1;
					//return;
					break;
				}

			}
		}
	else
		{
		calcTabClr();
		}
	}

function resetTabClr()
	{
	dump("\nColorfulTabs Log: resetTabClr");
	var clrObj = document.popupNode;
	if(clrObj.className=='tabbrowser-tabs')
		{
		clrObj=gBrowser.selectedTab;
		}
	//var params = {inn:{oldColor:document.defaultView.getComputedStyle(document.getAnonymousNodes(clrObj)[0], null).getPropertyValue("background-color"), enabled:0}, out:null};
	//window.openDialog('chrome://clrtabs/content/clrpkr.xul','_blank','modal,chrome,centerscreen,resizable=no, dialog=yes,close=no', params).focus();
	//if (params.inn.enabled)
	//	{
		// User clicked ok. Process changed arguments; e.g. write them to disk or whatever
		//var clrNewColor = params.inn.oldColor;
		setColor(clrObj, "-moz-dialog");
		ss.setTabValue(clrObj, "ctreadonly", 0);
		dump("\nset readonly "+ss.getTabValue(clrObj,"ctreadonly"));
		setTaBottomClr();
	//	}
		
	}
	

/********************************************************************************************************
**add "Color" to tab context menu************************************************************************
*********************************************************************************************************
********************************************************************************************************/
function initTabcontext()
	{
	dump("\nColorfulTabs Log: initTabcontext "+!document.getElementById('ctTabCtx'));
//var clrWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
//        	           .getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser").getBrowser();
	if(Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("extensions.clrtabs.menu").toString()=='true')
		{
		dump('\n\t\tappending');
		var clrMenu1 = document.createElement("menu");
		clrMenu1.setAttribute("label","ColorfulTabs");
		clrMenu1.setAttribute("id","ctTabCtx");

		var clrMenu2 = document.createElement("menupopup");
		clrMenu1.appendChild(clrMenu2);

    		var clrMenu3 = document.createElement("menuitem");
    		clrMenu3.addEventListener("command",setUserClr,false);
		clrMenu3.setAttribute("label", "Tab Color");
		clrMenu2.appendChild(clrMenu3);
		
		var clrMenu3a = document.createElement("menuitem");
		clrMenu3a.addEventListener("command",resetTabClr,false);
		clrMenu3a.setAttribute("label", "Reset Color");
		clrMenu2.appendChild(clrMenu3a);

		var clrMenu4 = document.createElement("menuitem");
		clrMenu4.addEventListener("command",showOptions,false);
		clrMenu4.setAttribute("label", "Options");
		clrMenu2.appendChild(clrMenu4);

		var ctSep = document.createElement("menuseparator");
		ctSep.setAttribute('id','ctsep')
		/*var clrMenu5 = document.createElement("menuitem");
		clrMenu5.addEventListener("command",remTabCtx,false);
		clrMenu5.setAttribute('label',"Remove Context Menu");
		clrMenu2.appendChild(clrMenu5);*/
    		setTimeout(function()
    			{
			window.getBrowser().mStrip.childNodes[1].appendChild(ctSep);
    			window.getBrowser().mStrip.childNodes[1].appendChild(clrMenu1);
    			}, 0);
    		//for(var tempVar=0;tempVar<gBrowser.childNodes.length;dump('\n'+gBrowser.childNodes[tempVar].nodeName),tempVar++);
    		

		}
	else
		{
		if(document.getElementById('ctsep'))
		try
			{
			var ctwm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var ctenumerator = ctwm.getEnumerator('navigator:browser');
			var ctwin;//,winlen;
			//winlen=0;
			var ctItem1,ctItem2,ctBrowser;
			dump('\n\t\tremoving '+ ctenumerator);
			while(ctenumerator.hasMoreElements())
				{
				//winlen++;
				ctwin = ctenumerator.getNext();
				//dump('\n\t\t'+winlen);
				ctItem1 = ctwin.document.getElementById('ctsep');
				ctItem2 = ctwin.document.getElementById('ctTabCtx');
				ctBrowser = ctwin.getBrowser();
				ctBrowser.mStrip.childNodes[1].removeChild(ctItem1);
				//alert(winlen);
			 	ctBrowser.mStrip.childNodes[1].removeChild(ctItem2);
				// |win| is [Object ChromeWindow] (just like |window|), do something with it
				}

			/*setTimeout(function()
			    	{
				window.getBrowser().mStrip.childNodes[1].removeChild(window.getElementById('ctsep'));
			    	window.getBrowser().mStrip.childNodes[1].removeChild(window.getElementById('ctTabCtx'));
    				}, 0);
    			*/

			}
		catch(e){dump(e);return;}
		}
	//alert("back in inittabcontext");
	}



function showOptions()
	{
	//window.openDialog('chrome://clrtabs/content/clrtabsopt.xul','_blank','modal,chrome,centerscreen,resizable=no, dialog=yes,close=no').focus();
	var features = "chrome,centerscreen,resizable=no,dialog=yes,toolbar,close=no,dependent=yes";
	window.openDialog('chrome://clrtabs/content/clrtabsopt.xul','_blank',features);
	//window.openDialog('chrome://clrtabs/content/clrpkr.xul','_blank','resizable=no, dialog=yes,close=no', params).focus();
	}
/********************************************************************************************************
*********************************************************************************************************
**function setCtPref() manages extension preferences. preference is extensions.clrtabs.fadedeg *********
********************************************************************************************************/
function setCtPref()
	{
	dump("\nColorfulTabs Log: setCtPref");
	clrPrefObserver.register();
	var clrprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try
		{
		fadedeg = clrprefs.getIntPref("extensions.clrtabs.fadedeg");
		scheme = clrprefs.getIntPref("extensions.clrtabs.scheme");
		ctVersion = clrprefs.getCharPref("extensions.clrtabs.firstrun");
		txtreverse = clrprefs.getBoolPref("extensions.clrtabs.txtreverse");
		enabledomain=clrprefs.getBoolPref("extensions.clrtabs.enabledomain");
		domain1=clrprefs.getCharPref("extensions.clrtabs.domain1");
		//alert(domain1);
		domain2=clrprefs.getCharPref("extensions.clrtabs.domain2");
		domain3=clrprefs.getCharPref("extensions.clrtabs.domain3");
		domain4=clrprefs.getCharPref("extensions.clrtabs.domain4");
		domain5=clrprefs.getCharPref("extensions.clrtabs.domain5");
								
		clrdomain1=clrprefs.getCharPref("extensions.clrtabs.clrdomain1");
		clrdomain2=clrprefs.getCharPref("extensions.clrtabs.clrdomain2");
		clrdomain3=clrprefs.getCharPref("extensions.clrtabs.clrdomain3");
		clrdomain4=clrprefs.getCharPref("extensions.clrtabs.clrdomain4");
		clrdomain5=clrprefs.getCharPref("extensions.clrtabs.clrdomain5");
		
		if(clrprefs.getBoolPref("extensions.clrtabs.advanced")==false)//satmax,satmin,lummax,lummin;
			{			
			satmax=95;
			clrprefs.setIntPref("extensions.clrtabs.satmax",satmax);
			satmin=30;
			clrprefs.setIntPref("extensions.clrtabs.satmin",satmin);
			lummax=78;
			clrprefs.setIntPref("extensions.clrtabs.lummax",lummax);
			lummin=68;
			clrprefs.setIntPref("extensions.clrtabs.lummin",lummin);
			}
		else
			{
			satmax=clrprefs.getIntPref("extensions.clrtabs.satmax");
			satmin=clrprefs.getIntPref("extensions.clrtabs.satmin");
			lummax=clrprefs.getIntPref("extensions.clrtabs.lummax");
			lummin=clrprefs.getIntPref("extensions.clrtabs.lummin");
			}
		if(clrprefs.getBoolPref("extensions.clrtabs.bgpic")==true)
			{
			
			cl("url("+clrprefs.getCharPref("extensions.clrtabs.bgpicpath")+")");
			gBrowser.mTabContainer.style.backgroundImage="url("+clrprefs.getCharPref("extensions.clrtabs.bgpicpath")+")";
			gBrowser.mTabContainer.style.backgroundRepeat="repeat";
			
			}
		
		}
	catch(e)
		{
		dump(e);
		}
	}

var clrPrefObserver =
	{
	register: function()
		{
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		this._branch = prefService.getBranch("extensions.clrtabs.");
		this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this._branch.addObserver("", this, false);
		},

	unregister: function()
		{
		if(!this._branch) return;
		this._branch.removeObserver("", this);
		},

	observe: function(aSubject, aTopic, aData)
		{
		if(aTopic != "nsPref:changed") return;
		//aTopic indicates the specific change or action
		//aSubject reflects the object whose change or action is being observed
		//aData is an optional parameter or other auxiliary data further describing the change or action
		// aSubject is the nsIPrefBranch we're observing (after appropriate QI)
		// aData is the name of the pref that's been changed (relative to aSubject)
		dump('\nColorfulTabs Log: Pref Changed: '+aData);
		//var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.clrtabs.")
		//dump(\n'branch '+branch)
		var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.clrtabs.");
		switch (aData)
			{
			case "fadedeg":				
				fadedeg = prefBranch.getIntPref("fadedeg");
				fadeAllTabs();
				break;
			case "scheme":
				
				scheme = prefBranch.getIntPref("scheme");
				dump('\nColorfulTabs Log: Coloring Scheme Changed to:\t'+ scheme);
				break;
				//user chose to color tabs with URl scheme
			case "menu":				
				initTabcontext();				
				break;
			case "txtreverse":				
				txtreverse=prefBranch.getBoolPref("txtreverse");				
				break;
			case "enabledomain":
				enabledomain=prefBranch.getBoolPref("enabledomain");
				break;
			case "domain1":
				domain1=prefBranch.getCharPref("domain1");
				break;
			case "domain2":
				domain2=prefBranch.getCharPref("domain2");
				break;
			case "domain3":
				domain3=prefBranch.getCharPref("domain3");
				break;
			case "domain4":
				domain4=prefBranch.getCharPref("domain4");
				break;
			case "domain5":
				domain5=prefBranch.getCharPref("domain5");
				break;
			case "clrdomain1":
				clrdomain1=prefBranch.getCharPref("clrdomain1");
				break;
			case "clrdomain2":
				clrdomain2=prefBranch.getCharPref("clrdomain2");
				break;
			case "clrdomain3":
				clrdomain3=prefBranch.getCharPref("clrdomain3");
				break;
			case "clrdomain4":
				clrdomain4=prefBranch.getCharPref("clrdomain4");
				break;
			case "clrdomain5":
				clrdomain5=prefBranch.getCharPref("clrdomain5");
				break;
			case "advanced":				
				var adv=prefBranch.getBoolPref("advanced");				
				if(adv==false)
					{				
					satmax=95;
					satmin=30;
					lummax=78;
					lummin=68;						
					}
				else
					{					
					satmax=prefBranch.getIntPref("satmax");
					satmin=prefBranch.getIntPref("satmin");
					lummax=prefBranch.getIntPref("lummax");
					lummin=prefBranch.getIntPref("lummin");
					}
				dump('\ncolorfultabs log: clrprefs- '+satmax+ ' '+satmin+ ' '+lummax+ ' '+lummin);
				break;
			case "satmax":
				satmax=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getIntPref("extensions.clrtabs.satmax");
				break;
			case "satmin":
				satmin=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getIntPref("extensions.clrtabs.satmin");
				break;
			case "lummax":
				lummax=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getIntPref("extensions.clrtabs.lummax");
				break;
			case "lummin":
				lummin=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getIntPref("extensions.clrtabs.lummin");
				break;
			case "bgpicpath":
				gBrowser.mTabContainer.style.backgroundImage="url("+prefBranch.getCharPref("bgpicpath")+")";
				gBrowser.mTabContainer.style.backgroundRepeat="repeat";
				break; 
			case "bgpic":
				cl("bgpic changed");
				var togglePic = prefBranch.getBoolPref("bgpic");
				cl("bgpic is= "+ togglePic);
				if(togglePic)
					{
					gBrowser.mTabContainer.style.backgroundImage="url("+prefBranch.getCharPref("bgpicpath")+")";
					gBrowser.mTabContainer.style.backgroundRepeat="repeat";
					}
				else
					{
					gBrowser.mTabContainer.style.backgroundImage="none";
					gBrowser.mTabContainer.style.backgroundRepeat="no-repeat";					
					}
			}
		//return false;
		}
	}


/********************************************************************************************************
**function calcTabClr is called when a tab is added******************************************************
*********************************************************************************************************
********************************************************************************************************/
function calcTabClr(event)
	{
	cl("calcTabClr");
	//dump("\ncalcTabClr tab open event: "+event.target.nodeName+" "+event.originalTarget.nodeName);
	var tab;
	var clrSat,clrLum,tabClr;
	if(event)
		{
		tab = event.originalTarget;
		}
	else
		{
		tab = gBrowser.mTabContainer.childNodes[0];
		}
	dump("\nTab readonly? "+ss.getTabValue(tab,"ctreadonly"));
	switch (scheme)
		{
		case 0:
			// extensions.myextension.fadedeg was changed //user chose to color tabs with default palette
			//dump('\nscheme value: default');
				if(ss.getTabValue(tab,"ctreadonly") == 1)
					{
					return;
					}
				dump("\nColorfulTabs Log: clr before: "+clr);
				tabClr = tabColors[clr%32];
				setColor(tab,tabClr);
				clr++;
				/*
				if(clr>31)
					{
					clr = 0;
					dump("\nreset to 0 \n");
					}
				if((clr-1)<0)
					{
					clr = 0;
					dump("\tnegative \n");
					}
				*/
				//ss.setTabValue(tab, "tabClr", tabClr);

			break;
		case 1:

				//dump('\nscheme value: random');
				//user chose to color tabs randomly
				if(ss.getTabValue(tab,"ctreadonly") == 1)
					{
					return;
					}
				var oldtabClr=ss.getTabValue(tab,"tabClr" );
				if(oldtabClr)
					{
					tabClr = oldtabClr;
					}
				else
					{
					clrSat = clrRand(satmin,satmax);	//for keeping saturation to match the old static template we need the saturation between 30 and 95;ideally could be min 30; add advanced  prefs later
					clrLum = clrRand(lummin,lummax);	//for keeping saturation to match the old static template we need the luminance between 68 and 78
					tabClr ='hsl('+Math.abs(clrHash(tab.getAttribute('linkedpanel').replace(/panel/,"")))%360+','+clrSat+'%,'+clrLum+'%)';
					}
				//ss.setTabValue(tab, "tabClr", tabClr);
				setColor(tab,tabClr);
				dump('\n'+satmin+' '+satmax+' '+lummin+ ' '+lummax);
			break;
		case 2:

				//user chose to color tabs with URl scheme
				tab.linkedBrowser.addProgressListener(clrUrlListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
				/* if tab is colored manually do not addProgressListener
				try
					{
					//alert('Hi');
					setColor(tab,ss.getTabValue(tab, "tabClr"));
					}
				catch(e) {dump("\nColorfultabs Log: restore failed because of "+e); }
				*/
			break;
		}
	}
/*
var oldtabClr=ss.getTabValue(tab,"tabClr" );
if(oldtabClr)
	{
	tabClr = oldtabClr;
	}

*/


/********************************************************************************************************
**Takes a tab node and a complete color string and colors that tab***************************************
*********************************************************************************************************
********************************************************************************************************/
function setColor(tab, tabClr)
	{	
	/*
	for(var i=0;i<document.getAnonymousNodes(tab).length;i++)
		{
		document.getAnonymousNodes(tab)[i].style.setProperty("background-color", tabClr ,'');
		}
	*/
	tab.style.setProperty('background-color',tabClr,'important');
	if(txtreverse)
		{
		cl("txtreverse="+txtreverse);
		rgb = document.defaultView.getComputedStyle(tab, null).getPropertyValue("background-color").toString();		
		rgb = rgb.replace(/ /g,''); //strip spaces
		re = /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/;
		rgb.toLowerCase();
		re.exec(rgb);
		r = RegExp.$1
		g = RegExp.$2;
		b =	RegExp.$3;
		cl('color:\trgb('+(255-parseInt(r))+','+(255-parseInt(g))+','+(255-parseInt(b))+')');
		tab.style.setProperty('color','rgb('+(255-parseInt(r))+','+(255-parseInt(g))+','+(255-parseInt(b))+')','important');
		}
	ss.setTabValue(tab, "tabClr", tabClr);
	
	fadeAllTabs();
	}




function getMovedTab(event)
	{
	
	if(event.originalTarget.nodeName == "tab" || event.originalTarget.nodeName == "xul:tab")
		{
		//var myClr = document.defaultView.getComputedStyle(document.getAnonymousNodes(event.originalTarget)[0], null).getPropertyValue("background-color");
		var myClr = ss.getTabValue(event.originalTarget, "tabClr");
		//event.originalTarget.getAttribute('tabClr');
		setColor(event.originalTarget,myClr)
		//dump("\nMoved Tab's Color is:\t"+myClr);
		}
	}


function restoreTabClr(event)
	{
	
	var tab = event.originalTarget;
	var myClr = ss.getTabValue(tab, "tabClr");
	setColor(tab,myClr);
	}




/********************************************************************************************************
**generate string hash for calculating color*************************************************************
*********************************************************************************************************
********************************************************************************************************/
function clrHash(clrString)
	{
	//cl("clrHash"+clrString);
	
	var hash = SHA256(clrString);
	var iClr, clrConst = 5381;// var clrString = ;
		for (iClr = 0; iClr < hash.length; iClr++)
		{
		clrConst = ((clrConst << 5) + clrConst) + hash.charCodeAt(iClr);
		}
	return clrConst;
	}

/*

function clrHash(strRand)
	{
	var hash = SHA256(strRand);
	dump('\ncolorfultabs log: hash:\t'+hash);
	var clr=0;
	for (var i=0;i<hash.length;i++)
		{
		clr=hash.charCodeAt(i)+clr;
		}
	dump('\n\n\nColorfulTabs Log:clr\t'+clr);
	return clr;
	}
*/
/********************************************************************************************************
**generate random value for calculating Saturation and Luminence*****************************************
*********************************************************************************************************
********************************************************************************************************/
function clrRand(min,max)
	{
	//dump("\nclrRand");
	return (Math.round(Math.random()*(max-min)))+min;
	}




/********************************************************************************************************
*********************************************************************************************************
**function tabrem is called when a tab is removed********************************************************
********************************************************************************************************/
function tabrem(event)
	{
	dump("\nColorfulTabs Log: tabrem");
	var tab = event.originalTarget.nodeName;
	//ss.setTabValue(tab, "tabClr", tabClr);
	//tn -= 1;
	}


function cl(msg)
	{
	dump("\ncl:\t"+msg);
	}

function fadeNode(node,opacity)
	{
	node.style.setProperty('-moz-opacity',opacity,'important');
	}
/********************************************************************************************************
*********************************************************************************************************
**function fadeAllTabs() is called on adding new tab and also on loading new window**********************
********************************************************************************************************/
function fadeAllTabs(event)
	{	
	
	//dump("\nColorfulTabs Log: fadeAllTabs");
	setTaBottomClr();
	//setCtPref();
	try
		{
		var tblength = gBrowser.mPanelContainer.childNodes.length;
		for(var loop = 0; loop < tblength; loop++)
			{
			try
				{
				//dump("\n\n\tnodes length "+document.getAnonymousNodes(gBrowser.mTabContainer.childNodes[loop]).length);
				if (fadedeg)
					{
					for(var count=0;count< gBrowser.mTabContainer.childNodes.length;count++)						
						fadeNode(gBrowser.mTabContainer.childNodes[count],(10-fadedeg)/10);						
					}
				else
					{					
					for(var count=0;count<gBrowser.mTabContainer.childNodes.length;count++)
						fadeNode(gBrowser.mTabContainer.childNodes[count],'1');
					}
				}
			catch(e)
				{
				Components.utils.reportError(e);
				}
			}
		}
	catch(e)
		{
		dump("\nColorfulTabs Log: Error: " + e);
		}
	if(fadedeg)
		{
		try
			{
			//dump("\n event type: "+event.type);
			//for(var count2 = 0; count2 < document.getAnonymousNodes(gBrowser.selectedTab).length ; count2++)
			fadeNode(gBrowser.selectedTab,"1");
			}
		catch(e)
			{
			dump("\nColorfulTabs Error in function fadeAllTabs: "+e+". Iteration failed on value "+count2);
			}
		}
	}




/*/ repair the following function so that it can be used instead of fadealltabs()
function fadeTab(event)
	{
	//	dump("\nfadeTabs");
	if(!event) return;
	setTaBottomClr();
	setCtPref();
	var oldTab = lastSelectedTab;
	var newTab = event.originalTarget;
	lastSelectedTab = newTab;
	//dump("\nSelection Target: "+event.target.nodeName+" "+event.originalTarget.nodeName);
	try
		{

			//dump('\nURL: '+gBrowser.mTabContainer.childNodes[loop].linkedBrowser.currentURI.spec);

				if (fadedeg && oldTab)
					{
					oldTab.style.setProperty('-moz-opacity',((10-fadedeg)/10).toString(),'important');//setAttribute("fade",fadedeg);
					dump("\ndumping fadetab target: "+oldTab.style.getPropertyValue('-moz-opacity'));
					newTab.style.setProperty('-moz-opacity','1','important');//setAttribute("fade",fadedeg);
					dump("\nnew tabs opaciti"+newTab.style.getPropertyValue('-moz-opacity'));

					}
				else
					{
					oldTab.style.setProperty('-moz-opacity','1','important');//setAttribute("fade",fadedeg);
					dump("\nelse dumping fadetab target: "+event.target.nodeName+" "+event.originalTarget.nodeName);
					newTab.style.setProperty('-moz-opacity','1','important');//setAttribute("fade",fadedeg);
					//lastSelectedTab=event.target;
					}

		}
	catch(e)
		{
		dump("FadeTab error: Clrtb: Initilisation failed to attach: " + e + "\n");
		}
	if(fadedeg)
		{
		//gBrowser.selectedTab.removeAttribute("fade");
		gBrowser.selectedTab.style.setProperty("-moz-opacity","1","important");
		}
	}
*/




/********************************************************************************************************
**function setTaBottomClr() is an attempt to catch the clrtabs stylesheet from all the stylesheets attached*****
to the window.*******************************************************************************************
********************************************************************************************************/
function setTaBottomClr()
	{

	/* old version
	gBrowser.mTabContainer.childNodes[(gBrowser.mPanelContainer.childNodes.length)-1].setAttribute("clrclass", clr);
	//*******
	//var tabtm = this.getElementsByAttribute("class","tabs-bottom").setAttribute("background-color","#00ff00");
	*/
	//dump("\nColorfulTabs Log: setTaBottomClr");
	var ss = new Array();
	var ss = document.styleSheets;
	for (var i=0; i < ss.length; i++)
		{
		switch (ss[i].href)
			{
			case 'chrome://clrtabs/skin/clrtabs.css':
				var clrSS = ss[i];
				break;
			}
		}
	try
		{
		//clrSS.cssRules[2].style.setProperty ('background-color',document.defaultView.getComputedStyle(document.getAnonymousNodes(gBrowser.selectedTab)[0], null).getPropertyValue("background-color").toString() ,'important' );
		clrSS.cssRules[2].style.setProperty ('background-color',document.defaultView.getComputedStyle(gBrowser.selectedTab, null).getPropertyValue("background-color").toString() ,'important' );
		}
	catch(e)
		{
		dump("\nctlog:\terror in function setTaBottomClr "+e);
		}
	}




/********************************************************************************************************
*********************************************************************************************************
**function effectMouseIn() is called on mouseover event**************************************************
********************************************************************************************************/
function effectMouseIn(event)
	{
	if (event.target.nodeName != "xul:tab" && event.target.nodeName != "tab") { return; }
	if((event.target.getAttribute('selected')=='true') ||(event.target.nodeName=='xul:tabs'))
		return;
	try
		{
		fadeNode(event.target,1);
		}
	catch(e)
		{
		dump("\nColorfulTabs Error in function effectMouseIn: "+e+". Iteration failed on value "+count2);
		}
	}




/********************************************************************************************************
*********************************************************************************************************
**function effectMouseOut() is called on mouseout event**************************************************
********************************************************************************************************/
function effectMouseOut(event)
	{
	if (event.target.nodeName != "xul:tab" && event.target.nodeName != "tab") { return; }
	if((event.target.getAttribute('selected')=='true') ||(event.target.nodeName=='xul:tabs'))
		return;
	try
		{
		fadeNode(event.target,(10-fadedeg)/10);
		}
	catch(e)
		{
		dump("\nColorfulTabs Error in function effectMouseOut: "+e+". Iteration failed on value "+count2);
		//dump("\nnColorfulTabs Log: nodes length "+document.getAnonymousNodes(event.target).length);
		}
	}




/********************************************************************************************************
** This is not a toy. This is an object and I'm not used to them. Go back to old days of C++ ************
*********************************************************************************************************
********************************************************************************************************/
//gBrowser.addProgressListener(clrUrlListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
//const CLR_STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;	//only used for onStateChange
//const CLR_STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;	//only used for onStateChange
var clrUrlListener =
	{
	QueryInterface: function(aIID)
		{
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) || aIID.equals(Components.interfaces.nsISupportsWeakReference) || aIID.equals(Components.interfaces.nsISupports))
     			return this;
		throw Components.results.NS_NOINTERFACE;
		},

	onLocationChange: function(aProgress, aRequest, aURI)
		{
		// This fires when the location bar changes i.e load event is confirmed
		// or when the user switches tabs. So... we could use the tabselect event to color the tab in case of color-by-url
		cl("location changed");
		var doc = aProgress.DOMWindow.document;
		var tab = gBrowser.mTabs[gBrowser.getBrowserIndexForDocument(doc)];
		cl("Tab readonly? "+ss.getTabValue(tab,"ctreadonly"));
		if(ss.getTabValue(tab,"ctreadonly") == 1)
			{
			return;
			}
		//var clrSat;
		//var clrLum;
		var tabClr;
		try
			{
			cl("trying");
			// stupid about:blank
			var host = tab.linkedBrowser.contentDocument.location.host;
			var url = tab.linkedBrowser.contentDocument.location;
			var testWWW = /^www\.(.+\..+)$/.exec(host);
			/*if(testWWW) 
				{
				host = testWWW[1];
				}
			*/
			cl("hosthash:"+clrHash(host));
			//cl("urlhash:"+clrHash(url));
			tabClr = 'hsl('+Math.abs(clrHash(host))%360+','+60+'%,'+73+'%)'; //use fixed values for sat and lum for host. to do - will use userprefs later for them - 
			cl("comp begins");
			cl("host is :"+host);
			cl("pref domain is: "+domain1);
			cl("match is: "+host.match(domain1)?true:false);
			cl("comp ends");
			if(enabledomain)
				{
					if(host.match(domain1))
						{
						tabClr = clrdomain1;
						}
					else
						{
						if(host.match(domain2))
							{
							tabClr = clrdomain2;
							}
						else
							{
							if(host.match(domain3))
								{
								tabClr = clrdomain3;
								}
							else
								{
								if(host.match(domain4))
									{
									tabClr = clrdomain4;
									}
								else
									{
									if(host.match(domain5))
										{
										tabClr = clrdomain5;
										}
									else
										{
										//default
										tabClr = 'hsl('+Math.abs(clrHash(host))%360+','+60+'%,'+73+'%)';
										}
									}
								}
								
							}
						}


				}
			cl(tabClr);
			
			setColor(tab,tabClr);			
			
			}
		catch (e)
			{
			var host = "about:blank"; // might not always be true, but this makes us ignore it.
			tabClr ='-moz-dialog'; //use fixed values for sat and lum for host. to do - will use userprefs later for them
			}
		//dump("\nHost is:\t"+host+"\ttabcolor\t"+tabClr);
		//return host; //this is the url
		//clrHash(host);
		//setColor(tab,tabClr)
		//ss.setTabValue(tab, "tabClr", tabClr);
		},
	// For definitions of the remaining functions see XulPlanet.com
	onStateChange:       function() { return 0; },
	onProgressChange: function() {return 0;},
	onStatusChange: function() {return 0;},
	onSecurityChange: function() {return 0;},
	onLinkIconAvailable: function() {return 0;}
	}









/********************************************************************************************************
**Open the Color Picker and Color the tab to the new color***********************************************
*********************************************************************************************************
********************************************************************************************************/
function setUserClr()
	{
	dump("\nColorfulTabs Log: setUserClr");
	var clrObj = document.popupNode;
	if(clrObj.className=='tabbrowser-tabs')
		{
		clrObj=gBrowser.selectedTab;
		}
	//var params = {inn:{oldColor:document.defaultView.getComputedStyle(document.getAnonymousNodes(clrObj)[0], null).getPropertyValue("background-color"), enabled:0}, out:null};
	var params = {inn:{oldColor:document.defaultView.getComputedStyle(clrObj, null).getPropertyValue("background-color"), enabled:0}, out:null};
	window.openDialog('chrome://clrtabs/content/clrpkr.xul','_blank','modal,chrome,centerscreen,resizable=no, dialog=yes,close=no', params).focus();
	if (params.inn.enabled)
		{
		// User clicked ok. Process changed arguments; e.g. write them to disk or whatever
		var clrNewColor = params.inn.oldColor;
		setColor(clrObj, clrNewColor.toString());
		ss.setTabValue(clrObj, "ctreadonly", 1);
		dump("\nset readonly "+ss.getTabValue(clrObj,"ctreadonly"));
		setTaBottomClr();
		}
	else
		{
		// User clicked cancel. Typically, nothing is done here.
		}
	}

function SHA256(s)
	{
	var chrsz   = 8;  
	var hexcase = 0;  
	   
	function safe_add (x, y)
		{  
		var lsw = (x & 0xFFFF) + (y & 0xFFFF);  
		var msw = (x >> 16) + (y >> 16) + (lsw >> 16);  
		return (msw << 16) | (lsw & 0xFFFF);  
		}  
   
	function S (X, n) { return ( X >>> n ) | (X << (32 - n)); }  
	function R (X, n) { return ( X >>> n ); }  
	function Ch(x, y, z) { return ((x & y) ^ ((~x) & z)); }  
	function Maj(x, y, z) { return ((x & y) ^ (x & z) ^ (y & z)); }  
	function Sigma0256(x) { return (S(x, 2) ^ S(x, 13) ^ S(x, 22)); }  
	function Sigma1256(x) { return (S(x, 6) ^ S(x, 11) ^ S(x, 25)); }  
	function Gamma0256(x) { return (S(x, 7) ^ S(x, 18) ^ R(x, 3)); }  
	function Gamma1256(x) { return (S(x, 17) ^ S(x, 19) ^ R(x, 10)); }  

	function core_sha256 (m, l)
		{  
	var K = new Array(0x428A2F98, 0x71374491, 0xB5C0FBCF, 0xE9B5DBA5, 0x3956C25B, 0x59F111F1, 0x923F82A4, 0xAB1C5ED5, 0xD807AA98, 0x12835B01, 0x243185BE, 0x550C7DC3, 0x72BE5D74, 0x80DEB1FE, 0x9BDC06A7, 0xC19BF174, 0xE49B69C1, 0xEFBE4786, 0xFC19DC6, 0x240CA1CC, 0x2DE92C6F, 0x4A7484AA, 0x5CB0A9DC, 0x76F988DA, 0x983E5152, 0xA831C66D, 0xB00327C8, 0xBF597FC7, 0xC6E00BF3, 0xD5A79147, 0x6CA6351, 0x14292967, 0x27B70A85, 0x2E1B2138, 0x4D2C6DFC, 0x53380D13, 0x650A7354, 0x766A0ABB, 0x81C2C92E, 0x92722C85, 0xA2BFE8A1, 0xA81A664B, 0xC24B8B70, 0xC76C51A3, 0xD192E819, 0xD6990624, 0xF40E3585, 0x106AA070, 0x19A4C116, 0x1E376C08, 0x2748774C, 0x34B0BCB5, 0x391C0CB3, 0x4ED8AA4A, 0x5B9CCA4F, 0x682E6FF3, 0x748F82EE, 0x78A5636F, 0x84C87814, 0x8CC70208, 0x90BEFFFA, 0xA4506CEB, 0xBEF9A3F7, 0xC67178F2);  
	var HASH = new Array(0x6A09E667, 0xBB67AE85, 0x3C6EF372, 0xA54FF53A, 0x510E527F, 0x9B05688C, 0x1F83D9AB, 0x5BE0CD19);  
	var W = new Array(64);  
	var a, b, c, d, e, f, g, h, i, j;  
	var T1, T2;  
	m[l >> 5] |= 0x80 << (24 - l % 32);  
	m[((l + 64 >> 9) << 4) + 15] = l;  
	for ( var i = 0; i<m.length; i+=16 ) 
		{  
	a = HASH[0];  
	b = HASH[1];  
	c = HASH[2];  
	d = HASH[3];  
	e = HASH[4];  
	f = HASH[5];  
	g = HASH[6];  
	h = HASH[7];
	for ( var j = 0; j<64; j++)
		{
		if (j < 16) W[j] = m[j + i];  
		else W[j] = safe_add(safe_add(safe_add(Gamma1256(W[j - 2]), W[j - 7]), Gamma0256(W[j - 15])), W[j - 16]);  
		T1 = safe_add(safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(e, f, g)), K[j]), W[j]);  
		T2 = safe_add(Sigma0256(a), Maj(a, b, c));  
		h = g;  
		g = f;  
		f = e;  
		e = safe_add(d, T1);  
		d = c;  
		c = b;  
		b = a;  
		a = safe_add(T1, T2);  
		}  
	HASH[0] = safe_add(a, HASH[0]);  
	HASH[1] = safe_add(b, HASH[1]);  
	HASH[2] = safe_add(c, HASH[2]);  
	HASH[3] = safe_add(d, HASH[3]);  
	HASH[4] = safe_add(e, HASH[4]);  
	HASH[5] = safe_add(f, HASH[5]);  
	HASH[6] = safe_add(g, HASH[6]);  
	HASH[7] = safe_add(h, HASH[7]);  
	}  
	return HASH;  
	}  
	function str2binb (str)
		{ 
	var bin = Array();  
	var mask = (1 << chrsz) - 1;  
	for(var i = 0; i < str.length * chrsz; i += chrsz)
		{
		bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (24 - i%32);  
	}  
	return bin;  
	}  

	function Utf8Encode(string)
		{
		string = string.replace(/\r\n/g,"\n");  
		var utftext = "";  
		for (var n = 0; n < string.length; n++)
			{
			var c = string.charCodeAt(n);  
			if (c < 128)
				{
				utftext += String.fromCharCode(c);  
				}  
			else if((c > 127) && (c < 2048))
				{
				utftext += String.fromCharCode((c >> 6) | 192);  
				utftext += String.fromCharCode((c & 63) | 128);  
				}  
				else
				{
				utftext += String.fromCharCode((c >> 12) | 224);  
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);  
				utftext += String.fromCharCode((c & 63) | 128);  
				}  
			}  
		return utftext;  
	}  
	function binb2hex (binarray)
		{
	var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";  
	var str = "";  
	for(var i = 0; i < binarray.length * 4; i++)
		{
		str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +  
		hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);  
		}  
	return str;  
	}  
   
	s = Utf8Encode(s);  
	return binb2hex(core_sha256(str2binb(s), s.length * chrsz));
	}
	
function BrowseSGen()
	{
	//openURL('http://www.binaryturf.com');
	gBrowser.selectedTab = gBrowser.addTab('http://www.binaryturf.com'); 
	}